unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls,Players,SaveBestand, Menus, Unit2, Buttons;

type
  TForm1 = class(TForm)
    DardBordGroup: TGroupBox;
    MouseOverLabel: TLabel;
    Image1: TImage;
    Edit1: TEdit;
    ScoreGroup: TGroupBox;
    Button1: TButton;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    Memo1: TMemo;
    Memo2: TMemo;
    Label2: TLabel;
    Label3: TLabel;
    MainMenu1: TMainMenu;
    b1: TMenuItem;
    Open1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    Edit2: TEdit;
    MouseClickLabel: TLabel;
    Button2: TButton;
    GemP1: TLabel;
    GemP2: TLabel;
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormResize(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);
    Procedure ZetWedstrijdUp;
    procedure Button2Click(Sender: TObject);
    Procedure ZetComboBox;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  VeldWaarde:Array[0..19] of byte;
  Wedstrijd:TWedstrijd;
  Bestand:TBestand;
  ClickArray:Array[0..3] of byte;//0e+1e+2e =Score 3e is welke beurt
implementation

Procedure TForm1.ZetComboBox;
begin
        if Bestand.Namen.Count >0 then
        begin
                ComboBox1.Sorted:=true;ComboBox2.Sorted:=true;
                ComboBox1.items :=(Bestand.Namen);ComboBox1.Text  :=ComboBox1.Items.Strings[0];
                ComboBox2.items :=(Bestand.Namen);ComboBox2.Text  :=ComboBox2.Items.Strings[0];
        end;
end;

Procedure TForm1.ZetWedstrijdUp;
var i:Byte;
    j:Integer;
begin
        if Wedstrijd<> nil then
        begin
                ComboBox1.Text :=Wedstrijd.Player1.Naam;
                ComboBox2.Text :=Wedstrijd.Player2.Naam;
                Memo1.Clear; Memo2.Clear;
                for i:=1 to (Length(Wedstrijd.Player1.Punten)) do
                        Memo1.Lines.Add(IntToStr(Wedstrijd.Player1.Punten[i-1]));
                for i:=1 to (Length(Wedstrijd.Player2.Punten)) do
                        Memo2.Lines.Add(IntToStr(Wedstrijd.Player2.Punten[i-1]));
                Case Wedstrijd.WedstrijdType of
                type301:j:=301;
                type501:j:=501;
                end;
                label2.caption:=IntToStr(j- Wedstrijd.Player1.PuntenTotaal);
                label3.caption:=IntToStr(j- Wedstrijd.Player2.PuntenTotaal);

                GemP1.Caption :='100: ' + IntToStr(Wedstrijd.Player1.P100);
                GemP1.Caption :=GemP1.Caption+' 140: ' + IntToStr(Wedstrijd.Player1.P140);
                GemP1.Caption :=GemP1.Caption+' 180: ' + IntToStr(Wedstrijd.Player1.P180);
                GemP1.Caption :=GemP1.Caption+' Gem: ' + FloatToStr(round(Wedstrijd.Player1.Gemideld*100)/100);

                GemP2.Caption :='100: ' + IntToStr(Wedstrijd.Player2.P100);
                GemP2.Caption :=GemP2.Caption+' 140: ' + IntToStr(Wedstrijd.Player2.P140);
                GemP2.Caption :=GemP2.Caption+' 180: ' + IntToStr(Wedstrijd.Player2.P180);
                GemP2.Caption :=GemP2.Caption+' Gem: ' + FloatToStr(round(Wedstrijd.Player2.Gemideld*100)/100);

                If ((StrToInt(Label2.Caption))<0) or ((StrToInt(Label3.Caption))<0)
                or ((StrToInt(Label2.Caption))=1) or ((StrToInt(Label3.Caption))=1) then
                begin
                        Wedstrijd.RemovePunt;
                        Wedstrijd.AddPunt(0);
                        ZetWedstrijdUp;
                end;

                If ((((StrToInt(Label2.Caption))=0) or ((StrToInt(Label3.Caption))=0)))  then
                begin
                        //Alleen wedstrijd opslaan als deze NIET uit een bestand komt.
                        if not(Wedstrijd.FromFile) And (Application.MessageBox('Je hebt gewonnen, wedstrijd opslaan?','Winner',MB_OKCANCEL + MB_DEFBUTTON1) = IDOK) then
                        begin
                                Bestand.WedstrijdNaarBestand(Bestand.FileNaam,Wedstrijd);
                                Bestand.VanBestand(Bestand.FileNaam,0);//Up to date zetten.
                                ZetComboBox;
                                ComboBox1.Text:=Wedstrijd.Player1.Naam;
                                ComboBox2.Text:=Wedstrijd.Player2.Naam;
                        end;
                        //Stop wedstrijd
                        Form1.Button1Click(TButton(Button1));
                end;
        end;
end;

{$R *.DFM}
Function Posities(const S:String;i:Byte):String;
var str:String;
begin
        str:='';
        While i>Length(s) do
        begin
                Setlength(Str,Length(str)+1);
                Str[Length(Str)]:=' ';
                dec(i);
        end;
        result:=str+S;
end;

Procedure MaakClickLabel;
var i:Byte;
    s:String;
    tot:Integer;
    Enter:Char;
begin
        Enter:=Chr(13);
        s:=Posities(IntToStr(ClickArray[0]),3);
        if ClickArray[3]>0 then s:=s+'*';
        For i:=1 to 2 do
        begin
                s:=s + Enter + Posities(IntToStr(ClickArray[i]),3);
                if ClickArray[3]>i then s:=s+'*';
        end;
        tot:=ClickArray[0]+ClickArray[1]+ClickArray[2];

        s:=s + Enter + Posities(IntToStr(tot),3);
        form1.MouseClickLabel.Caption :=s;
        form1.Edit2.Text :=IntToStr(tot);
end;

Function RGB(Red,Green,Blue:Byte):TColor;
begin
        Result:=((Red)+(Green*256)+(Blue*256*256));
end;

Function CircelDraw(Center:TPoint;Width:Integer):TRect;
var Rec:Trect;
begin
        rec.Right :=Center.x-Width;
        rec.Left  :=Center.x+Width;
        rec.Top   :=Center.y-Width;
        rec.Bottom:=Center.y+Width;
        Result:=Rec
end;

Procedure DrawDartBord;
var Center,Point1,Point2:Tpoint;
    R,R2:real;
    i:Integer;
    P3x,P3y:Real;
    Bord:TImage;
    Kleur1,Kleur2,Kleur3,Kleur4:TColor;
begin
        Bord:=TImage.Create(Form1.Image1);
        Bord.Width:=Form1.Image1.width;
        Bord.Height :=Form1.Image1.Height;

        R:=Bord.Width;
        if Bord.Height<R then
                R:=Bord.Height;
        R:=(Round(R) div 2) /1700;
        Center.x:=Bord.Width div 2;
        Center.y:=Bord.Height div 2;
        Bord.Canvas.Pen.Color :=Clgray;
        Bord.Canvas.Pen.Width :=1;
        //Circkels van buiten naar binnen.
        Bord.canvas.Ellipse(CircelDraw(Center,Round(R*1700  )));
        Bord.Canvas.Ellipse(CircelDraw(Center,Round(R*1620  )));
        Bord.Canvas.Ellipse(CircelDraw(Center,Round(R*1070  )));
        Bord.Canvas.Ellipse(CircelDraw(Center,Round(R* 990  )));
        Bord.Canvas.Ellipse(CircelDraw(Center,Round(R* 159  )));
        Bord.Canvas.Ellipse(CircelDraw(Center,Round(R*  63.5)));
        // de 20 lijnen.
        Kleur1:=RGB(230,170,23);
        Kleur2:=RGB(48,32,22);
        Kleur3:=RGB(180,12,12);
        Kleur4:=RGB(50,120,40);
        Bord.Canvas.Font.Color := 0;
        Bord.Canvas.Font.Style := [fsBold];
        for i:=0 to 19 do
        begin
                R2 := ((360 / 20 * i + 9) * pi/180);
                point1.x:=Center.x+ Round(Sin(R2)* 155*R);
                point1.y:=Center.y+ Round(Cos(R2)* 155*R);
                point2.x:=Center.x+ Round(Sin(R2)*1710*R);
                point2.y:=Center.y+ Round(Cos(R2)*1710*R);
                R2 := ((360 / 20 * (i+1)) * pi/180);
                P3x:= (Sin(R2)*R);
                P3y:= (Cos(R2)*R);
                Bord.Canvas.polyline ([Point1,Point2]);

                If bord.Canvas.Brush.Color <> Kleur4 then
                        bord.Canvas.Brush.Color:=Kleur1
                else
                        bord.Canvas.Brush.Color:=Kleur2;

                Bord.Canvas.FloodFill(Center.x+Round(P3x* 800),Center.y+Round(P3y* 800),Bord.Canvas.Pen.Color,fsBorder);
                Bord.Canvas.FloodFill(Center.x+Round(P3x*1400),Center.y+Round(P3y*1400),Bord.Canvas.Pen.Color,fsBorder);
                Bord.Canvas.TextOut (Center.x+Round(P3x*1350)-5,Center.y+Round(P3y*1350)-8,IntToStr(Veldwaarde[i]));
                If bord.Canvas.Brush.Color = Kleur1 then
                        bord.Canvas.Brush.Color:=Kleur4
                else
                        bord.Canvas.Brush.Color:=Kleur3;

                Bord.Canvas.FloodFill(Center.x+Round(P3x*1030),Center.y+Round(P3y*1030),Bord.Canvas.Pen.Color,fsBorder);
                Bord.Canvas.FloodFill(Center.x+Round(P3x*1650),Center.y+Round(P3y*1650),Bord.Canvas.Pen.Color,fsBorder);
        end;
        Bord.Canvas.Brush.Color :=Kleur2;
        Bord.Canvas.FloodFill(Center.x+Round(P3x* 100),Center.y+Round(P3y* 100),Bord.Canvas.Pen.Color,fsBorder);
        Bord.Canvas.Brush.Color :=Kleur3;
        Bord.Canvas.FloodFill(Center.x+Round(P3x*   0),Center.y+Round(P3y*   0),Bord.Canvas.Pen.Color,fsBorder);
        Form1.Image1.Picture :=Bord.Picture;
        Bord.Free;
end;

procedure TForm1.Image1Click(Sender: TObject);
begin
        if ClickArray[3]>=3 then
        begin
                ClickArray[3]:=0;
                ClickArray[0]:=0;ClickArray[1]:=0;ClickArray[2]:=0;
        end;
        ClickArray[ClickArray[3]]:=StrToInt(Edit1.text);
        Inc(ClickArray[3]);

        MaakClickLabel;
end;

procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var Center:Tpoint;
    R,R2:Real;
    Maal,Graden:Integer;
    s:String;
begin
        R:=Form1.Image1.Width;
        if Form1.Image1.Height<R then
                R:=Form1.Image1.Height;
        R:=(Round(R) div 2) /1700;
        Center.x:=Form1.Image1.Width  div 2;
        Center.y:=Form1.Image1.Height div 2;
        R2:= (Sqrt(Sqr(Center.x-X) + Sqr(Center.y-Y))/R);

        case Round(R2) of
                 0..  64:Begin s :='Bulls eye';Maal:=2;Graden:=25;End;
                65.. 159:Begin s :='Bull'     ;Maal:=1;Graden:=25;End;
               160.. 990:Begin s :='Single'   ;Maal:=1;           End;
               991..1070:Begin s :='Tripple'  ;Maal:=3;           End;
              1071..1620:Begin s :='Single'   ;Maal:=1;           End;
              1621..1700:Begin s :='Double'   ;Maal:=2;           End;
        else
                         Begin s :='Mis'      ;Maal:=0;Graden:= 0;End;
        end;
        If (Round(R2)>159) and (Round(R2)<=1700) then
        begin
                Graden:=Round(ArcTan((Center.x-x+0.01)/(Center.y-y+0.01))/ pi*180);

                If ((Center.y-y) >= 0) Then
                        Graden := Graden + 180;
                Dec(Graden,9);
                If Graden<0 then Inc(Graden,360);
                Graden:=Trunc(Graden/360*20);

                Graden:=VeldWaarde[Graden];
                s:=s+' '+IntToStr(Graden);
        end;
        Edit1.Text := IntToStr(Maal*Graden);
        MouseOverLabel.Caption :=s;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
        VeldWaarde[ 0]:=17;VeldWaarde[ 1]:= 2;VeldWaarde[ 2]:=15;VeldWaarde[ 3]:=10;VeldWaarde[ 4]:= 6;
        VeldWaarde[ 5]:=13;VeldWaarde[ 6]:= 4;VeldWaarde[ 7]:=18;VeldWaarde[ 8]:= 1;VeldWaarde[ 9]:=20;
        VeldWaarde[10]:= 5;VeldWaarde[11]:=12;VeldWaarde[12]:= 9;VeldWaarde[13]:=14;VeldWaarde[14]:=11;
        VeldWaarde[15]:= 8;VeldWaarde[16]:=16;VeldWaarde[17]:= 7;VeldWaarde[18]:=19;VeldWaarde[19]:= 3;

        Bestand:=TBestand.Create;
        Bestand.VanBestand('Data.new',0);
        ZetComboBox;
end;

procedure TForm1.FormResize(Sender: TObject);
var i:Integer;
begin
        DardBordGroup.left:=8; DardBordGroup.Width  :=(Form1.ClientWidth div 2)-12;
        DardBordGroup.Top :=8; DardBordGroup.Height :=DardBordGroup.Width;

        ScoreGroup.Left   :=(Form1.ClientWidth div 2)+4;ScoreGroup.Width :=(Form1.ClientWidth div 2)-12;
        ScoreGroup.Top    :=8; ScoreGroup.Height :=DardBordGroup.Height;

        Image1.Picture :=nil;
        Image1.Left := 8; Image1.Width :=DardBordGroup.ClientWidth  -Image1.Left-8;
        Image1.Top  :=16; Image1.Height:=DardBordGroup.ClientHeight -Image1.Top -8;

        MouseOverLabel.Top  :=Image1.Top;
        MouseOverLabel.Left :=Image1.Left;
        MouseOverLabel.Caption :='';

        Edit1.Left:=(DardBordGroup.ClientWidth-Edit1.Width) -2;
        Edit1.Top :=8;

                MouseClickLabel.Top  :=Edit1.Top+Edit1.Height;
                MouseClickLabel.Left :=(Edit1.Left+Edit1.Width)-34;
                MaakClickLabel;

        Edit2.Left:=(DardBordGroup.ClientWidth-Edit2.Width) -2;
        Edit2.Top :=DardBordGroup.ClientHeight-Edit2.Height-2;

                Button2.Left:=(DardBordGroup.ClientWidth-Button2.Width) -2;
                Button2.Top :=Edit2.Top-Button2.Height-1;

        Button1.Left := (ScoreGroup.ClientWidth div 2)-(button1.Width div 2);
                ComBoBox1.Left := 16;
                ComBoBox1.Width :=Button1.Left-(ComBoBox1.Left +8);

                ComboBox2.Left :=Button1.Left+Button1.Width+8;
                ComBoBox2.Width:=ComBoBox1.Width;

                label2.left :=ComboBox1.Left;
                Label2.Width :=(ScoreGroup.ClientWidth div 2)-label2.left-4;
                Label2.Top := ComboBox1.Top+ComboBox1.Height+8;

                label3.left :=label2.left+label2.width+8;
                Label3.Width :=Label2.Width;
                Label3.Top := Label2.Top;

                Memo1.Left :=label2.Left;
                Memo1.Width:=label2.Width;
                Memo1.Top :=Label2.Top+Label2.Height+8;
                Memo1.Height :=ScoreGroup.ClientHeight -(Memo1.Top+Gemp1.Height+8);

                Memo2.Left :=label3.left;
                Memo2.Width :=label3.Width;
                Memo2.Top:=Memo1.Top;
                Memo2.Height:=Memo1.Height;

                Gemp1.Top :=Memo1.Top+Memo1.Height+4;
                Gemp1.Left:=Memo1.Left;
                Gemp1.Width :=Memo1.Width;
                Gemp2.Top :=Gemp1.Top;
                Gemp2.Left:=Memo2.Left;
                Gemp2.Width :=Memo2.Width;

        form1.Refresh;
        DrawDartBord;
        
end;


procedure TForm1.Button1Click(Sender: TObject);
begin
        if (Wedstrijd<>nil) then
        begin
                Button1.Caption:='Start';
                Wedstrijd.Free;
                Wedstrijd:=nil;
        end
        else
        begin
                Button1.Caption:='Stop';
                Wedstrijd:=TWedstrijd.create(ComboBox1.Text,ComboBox2.Text,Type501);
                Wedstrijd.FromFile :=False;
                ZetWedstrijdUp;
                Edit2.SetFocus;
        end;
end;


procedure TForm1.Exit1Click(Sender: TObject);
begin
        Application.Terminate;
end;

procedure TForm1.Open1Click(Sender: TObject);
begin
        Form2.Show;
        //Alleen als form2 wordt geshowed
        Form1.Enabled:=not(Form2.Showing );
end;


procedure TForm1.Edit2KeyPress(Sender: TObject; var Key: Char);
var i,j:Integer;
begin
        If key=chr(13) then
        begin
                key:=chr(0);
                If Wedstrijd <>nil then
                        Wedstrijd.AddPunt(StrToInt(Edit2.Text));
                ZetWedstrijdUp;
        end;

        Try
                Edit2.Refresh;
                i:=StrToInt((Edit2.Text + Key));
                //Controleer of dit een juist getal is voor 3 pijlen.
                //3* 0tot 20 | maar 2*25..bull !!
                Dec(i,120);
                //Laatste pijl controle.....
                if not((i<=20) or
                (i<=50) or
                (((i div 3)<=20) and ((i mod 3)=0)) or
                (((i div 2)<=20) and ((i mod 2)=0))) then
                        Edit2.text:='';

        except
                if key >chr(32) then
                        key:=chr(0);
        end;
end;


procedure TForm1.Button2Click(Sender: TObject);
begin
        If Wedstrijd <>Nil then
                Wedstrijd.RemovePunt;
        ZetWedstrijdUp;
end;

end.
